declare
  cur                sys_refcursor;
  user_src           varchar(128);
  user_dest          varchar(128) := '&PASS_PAR1';
  v_object_name      varchar(128) := '&PASS_PAR2';  /* added to give grant for specific table*/
  source_object      varchar(128);
  source_obj_type 	 varchar(128);
  plsql_statement    varchar(512);

begin
  select current_schema into user_src from sysibm.sysdummy1;

  -- GRANT FOR SPECIFIC TABLE,VIEW,SEQUENCE,FUNCTION,PROCEDURE,PACKAGE
  open cur for
		select t.table_name as dml, 'TABLE' Obj_type 
		from sysibm.tables t
		where ( t.table_type = 'BASE TABLE' or t.table_type is null ) 
		and t.table_schema = user_src
		and t.table_name = v_object_name
		UNION 
		select t.seqname dml,'SEQUENCE' Obj_type 
		from syscat.sequences t
		where t.seqschema = user_src and t.seqtype <> 'I'
		AND t.SEQNAME = v_object_name
		UNION
		select dml, Obj_type from
		(
			select t.funcname AS dml, 'FUNCTION' as Obj_type from syscat.functions t
			where t.funcschema = user_src
			AND t.funcname = v_object_name
			union
			select t.procname as dml, 'PROCEDURE' as Obj_type 
			from syscat.procedures t
			where t.procschema = user_src
			AND t.procname = v_object_name
			union
			select t.modulename as dml, 'MODULE' as Obj_type from syscat.modules t
			where t.moduleschema = user_src
			AND t.modulename = v_object_name
		)        
		UNION 
		select t.table_name dml, 'VIEW' Obj_type 
		from sysibm.tables t
		where t.table_type = 'VIEW' 
		and t.is_insertable_into = 'NO'
		and t.table_schema = user_src
		AND t.table_name = v_object_name;

  loop
    fetch cur into source_object,source_obj_type;
    exit when cur%NOTFOUND;
	
	if (source_obj_type = 'TABLE') then
		plsql_statement := 'GRANT SELECT ON "' || source_object || '" TO ' || user_dest;
	elsif(source_obj_type = 'SEQUENCE') then
		plsql_statement := 'GRANT USAGE ON SEQUENCE "' || source_object || '" TO ' || user_dest;
	elsif(source_obj_type = 'FUNCTION' or source_obj_type = 'PROCEDURE' or source_obj_type = 'MODULE') then
		 plsql_statement := 'GRANT EXECUTE ON "' || source_obj_type || '" "' || source_object || '" TO ' || user_dest;
	elsif(source_obj_type = 'VIEW') then
		plsql_statement := 'GRANT SELECT ON '|| source_object || ' TO ' || user_dest;
	end if;
    
    --dbms_output.put_line(plsql_statement);
    execute immediate(plsql_statement);
  end loop;
  close cur;
 
end;
/
commit;

