declare
  cur               	sys_refcursor;
  user_src          	varchar2(128);
  user_dest         	varchar2(128) := '&PASS_PAR1';
  v_object_name     	varchar2(128) := '&PASS_PAR2';  /* added to give grant for specific table*/
  source_object     	varchar2(128);
  source_obj_type 		varchar2(128);
  plsql_statement   	varchar2(512);

begin
  
  -- GRANT FOR SPECIFIC TABLE,VIEW,SEQUENCE,FUNCTION,PROCEDURE,PACKAGE
  open cur for
	select  object_name,object_type 
	from (select t.table_name object_name,'TABLE' object_type 
		 from all_tables t where t.table_name = v_object_name 
		 union
		 select t.synonym_name object_name,'TABLE' object_type 
		 from all_synonyms t, all_objects ao
		 where t.table_owner = ao.owner 
		 and t.synonym_name = ao.object_name
		 and ao.object_type = 'TABLE'
		 and t.synonym_name = v_object_name)
	union
		select  object_name,object_type 
		from(select t.sequence_name object_name,'SEQUENCE' object_type 
		from all_sequences t 
		WHERE t.sequence_name = v_object_name
		union
		select t.synonym_name object_name,'SEQUENCE' object_type 
		from all_synonyms t, all_objects ao
		where t.table_owner = ao.owner 
		and t.synonym_name = ao.object_name
		and ao.object_type = 'SEQUENCE'
		AND t.synonym_name = v_object_name)
	union
	select  object_name,object_type
	from(select distinct t.object_name,t.object_type from all_objects t
		 where t.object_type in ( 'FUNCTION', 'PACKAGE', 'PROCEDURE' )
		 and t.object_name <> 'COMPLEX_INDEX'
		 AND t.object_name = v_object_name
		 union
		 select t.synonym_name object_name,ao.object_type from all_synonyms t, all_objects ao
		 where t.table_owner = ao.owner and t.synonym_name = ao.object_name
		 and ao.object_type in ( 'FUNCTION', 'PACKAGE', 'PROCEDURE' )
		 and t.synonym_name <> 'COMPLEX_INDEX'
		 and t.synonym_name = v_object_name )
	union
	select  object_name,object_type 
	from (select distinct t.view_name object_name,'VIEW' object_type 
		  from all_views t 
		  where t.view_name = v_object_name
		  union
		  select t.synonym_name object_name,'VIEW' object_type 
		  from all_synonyms t, all_objects ao
		  where t.table_owner = ao.owner 
		  and t.synonym_name = ao.object_name
		  and ao.object_type = 'VIEW'
		  and ao.object_name = v_object_name);

  loop
    fetch cur into source_object,source_obj_type;
    exit when cur%NOTFOUND;
	
	if ( source_obj_type = 'TABLE' ) then
		plsql_statement := 'GRANT SELECT, DELETE, INSERT, UPDATE, REFERENCES ON ' || source_object || ' TO ' || user_dest;
	elsif( source_obj_type = 'SEQUENCE' ) then
		plsql_statement := 'GRANT SELECT, ALTER ON ' || source_object || ' TO ' || user_dest;
	elsif( source_obj_type = 'FUNCTION' or source_obj_type = 'PROCEDURE' or source_obj_type = 'MODULE' ) then
		plsql_statement := 'GRANT EXECUTE ON '|| source_object || ' TO ' || user_dest;
	elsif( source_obj_type = 'VIEW' ) then
		plsql_statement := 'GRANT SELECT ON '|| source_object || ' TO ' || user_dest;
	end if;
    execute immediate(plsql_statement);
  end loop;
  close cur;
end;
/
commit;

